// Jan Tomsa, verze 1.0, vyhotoveno 17.11.2005
//-------------------------------------------------------------------------
// loha . 18
//-------------------------------------------------------------------------
// Zadn:
// Napite  program,  kter  zkonvertuje  zdrojov textov
// soubor do morseovky a zape ji do novho souboru.
// voln: telegraf  zdroj_soubor  novy_soubor
//-------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

// Zstupn znaky pro binrn strom
#define CH 31
#define ALPHA '<'
#define BETA '>'

// Translation Table (pevodn tabulka) - binrn strom
// obsahuje v nejnim bitu informaci,
// zda pro dan znak zan peklad do morseovky tekou nebo rkou
// ve zbvajcch 7 bitech adresu, kterm znakem pokraovat
// pokud adresa dalho znaku je 0, skonit peklad
//  NNNNNNNO
//  \_____/^-- 0 .. "." / 1 .. "-"
//     ^------ adresa dalho znaku
//
// Pro znaky, kter nemaj dnou reprezentaci v morseovce obsahuje tabulka
//  slo 255
//
// pklad pouit pekladov tabulky pro psmeno "A"
// TRANS_TABLE['A'] == 10101000
//                     \_____/^-- 0   => "."
//                        ^------ 'T'
// TRANS_TABLE['T'] == 00000001
//                     \_____/^-- 1   => "-"
//                        ^------ 0   => konec
// vsledek: 'A' --> ".-"
unsigned char TRANS_TABLE[256] =
 { 0,  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,//(0-15)
   255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, // (16-30)
    ('O' << 1)+1,  //   (31) /CH/
    255,           // mezera (32)
    255,           // ! (33)
    255,           // " (34)
    255,           // # (35)
    255,           // $ (36)
    255,           // % (37)
    255,           // & (38)
    255,           // \ (39)
    255,           // ( (40)
    255,           // ) (41)
    255,           // * (42)
    255,           // + (43)
    255,           // , (44)
    255,           // - (45)
    255,           // . (46)
    255,           // / (47)
    (CH  << 1)+1,  // 0  (48)
    (CH  << 1)+0,  // 1  (49)
    ('J' << 1)+0,  // 2  (50)
    ('W' << 1)+0,  // 3  (51)
    ('V' << 1)+0,  // 4  (52)
    ('H' << 1)+0,  // 5  (53)
    ('H' << 1)+1,  // 6  (54)
    ('B' << 1)+1,  // 7  (55)
    ('Z' << 1)+1,  // 8  (56)
    (ALPHA << 1)+1,// 9  (57)
    255,           // :  (58)
    255,           // ;  (59)
    ('G' << 1)+1,  // <  (60) /ALPHA/
    255,           // =  (61)
    ('M' << 1)+0,  // >  (62) /BETA/
    255,           // ?  (63)
    255,           // @  (64)
    ('T' << 1)+0,  // A  (65)  ** 0-> "." ; pokrauj na indexu 'T'
    ('S' << 1)+1,  // B
    ('R' << 1)+1,  // C
    ('I' << 1)+1,  // D
    ( 0  << 1)+0,  // E
    ('R' << 1)+0,  // F
    ('N' << 1)+1,  // G
    ('S' << 1)+0,  // H
    ('E' << 1)+0,  // I
    ('O' << 1)+0,  // J
    ('A' << 1)+1,  // K
    ('D' << 1)+0,  // L
    ('T' << 1)+1,  // M
    ('E' << 1)+1,  // N
    ('M' << 1)+1,  // O
    ('G' << 1)+0,  // P
    ('K' << 1)+1,  // Q
    ('N' << 1)+0,  // R
    ('I' << 1)+0,  // S
    ( 0  << 1)+1,  // T  (84)  ** 1-> "-" ; pokrauj na indexu 0 (=konec)
    ('A' << 1)+0,  // U
    ('U' << 1)+0,  // V
    (BETA << 1)+0, // W
    ('U' << 1)+1,  // X
    (BETA << 1)+1, // Y
    ('D' << 1)+1,  // Z  (90)
    255,           // [  (91)
    255,           // \  (92)
    255,           // ]  (93)
    255,           // ^  (94)
    255,           // _  (95)
    255,           // `  (96)
    ('T' << 1)+0,  // a  (97)
    ('S' << 1)+1,  // b
    ('R' << 1)+1,  // c
    ('I' << 1)+1,  // d
    ( 0  << 1)+0,  // e
    ('R' << 1)+0,  // f
    ('N' << 1)+1,  // g
    ('S' << 1)+0,  // h
    ('E' << 1)+0,  // i
    ('O' << 1)+0,  // j
    ('A' << 1)+1,  // k
    ('D' << 1)+0,  // l
    ('T' << 1)+1,  // m
    ('E' << 1)+1,  // n
    ('M' << 1)+1,  // o
    ('G' << 1)+0,  // p
    ('K' << 1)+1,  // q
    ('N' << 1)+0,  // r
    ('I' << 1)+0,  // s
    ( 0  << 1)+1,  // t
    ('A' << 1)+0,  // u
    ('U' << 1)+0,  // v
    (BETA << 1)+0, // w
    ('U' << 1)+1,  // x
    (BETA << 1)+1, // y
    ('D' << 1)+1,  // z  (122)
    255,           // {  (123)
    255,           // |  (124)
    255,           // }  (125)
    255,           // ~  (126)
    0,             //    (127) - 0 kvli ukonen neex. znak
    255,           //   (128)
    255,           //    (129)
    255,           // 
    255,           //    (131)
    255,           // 
    255,           // 
    255,           // 
    255,           // 
    255,           //    (136)
    255,           //   (137)
    ('I' << 1)+0,  // 
    255,           // 
    ('I' << 1)+0,  // 
    ( 0  << 1)+1,  //   (141)
    ('D' << 1)+1,  //   (142)
    ('D' << 1)+1,  // 
    255,           //    (144)
    255,           // 
    255,           // 
    255,           // 
    255,           // 
    255,           //   (149)
    255,           // 
    255,           // 
    255,           //    (152)
    255,           // 
    ('I' << 1)+0,  // 
    255,           //   (155)
    ('I' << 1)+0,  // 
    ( 0  << 1)+1,  //   (157)
    ('D' << 1)+1,  // 
    ('D' << 1)+1,  // 
    255,           //    (160)
    255,           // 
    255,           //   (162)
    ('D' << 1)+0,  // 
    255,           // 
    ('T' << 1)+0,  // 
    255,           //   (166)
    255,           // 
    255,           // 
    255,           //   (169)
    ('I' << 1)+0,  //   (170)
    255,           // 
    255,           // 
    255,           // 
    255,           // 
    ('D' << 1)+1,  //   (175)
    255,           // 
    255,           // 
    255,           // 
    ('D' << 1)+0,  //   (179)
    255,           //   (180)
    255,           // 
    255,           // 
    255,           // 
    255,           // 
    ('T' << 1)+0,  //   (185)
    ('I' << 1)+0,  //   (186)
    255,           // 
    ('D' << 1)+0,  // 
    255,           // 
    ('D' << 1)+0,  //   (190)
    ('D' << 1)+1,  //   (191)
    ('N' << 1)+0,  // 
    ('T' << 1)+0,  // 
    ('T' << 1)+0,  // 
    ('T' << 1)+0,  // 
    ('T' << 1)+0,  // 
    ('D' << 1)+0,  //   (197)
    ('R' << 1)+1,  // 
    ('R' << 1)+1,  // 
    ('R' << 1)+1,  //   (200)
    ( 0  << 1)+0,  //   (201)
    ( 0  << 1)+0,  // 
    ( 0  << 1)+0,  // 
    ( 0  << 1)+0,  // 
    ('E' << 1)+0,  // 
    ('E' << 1)+0,  //   (206)
    ('I' << 1)+1,  // 
    ('I' << 1)+1,  // 
    ('E' << 1)+1,  // 
    ('E' << 1)+1,  //   (210)
    ('M' << 1)+1,  // 
    ('M' << 1)+1,  // 
    ('M' << 1)+1,  // 
    ('M' << 1)+1,  // 
    255,           //   (215)
    ('N' << 1)+0,  //   (216)
    ('A' << 1)+0,  //   (217)
    ('A' << 1)+0,  //   (218)
    ('A' << 1)+0,  // 
    ('A' << 1)+0,  //   (220)
    (BETA << 1)+1, // 
    ( 0  << 1)+1,  // 
    255,           // 
    ('N' << 1)+0,  // 
    ('T' << 1)+0,  //   (225)
    ('T' << 1)+0,  //   (226)
    ('T' << 1)+0,  //   (227)
    ('T' << 1)+0,  // 
    ('D' << 1)+0,  // 
    ('R' << 1)+1,  //   (230)
    ('R' << 1)+1,  // 
    ('R' << 1)+1,  // 
    ( 0  << 1)+0,  // 
    ( 0  << 1)+0,  // 
    ( 0  << 1)+0,  // 
    ( 0  << 1)+0,  // 
    ('E' << 1)+0,  //   (237)
    ('E' << 1)+0,  //   (238)
    ('I' << 1)+1,  // 
    ('I' << 1)+1,  //   (240)
    ('E' << 1)+1,  //   (241)
    ('E' << 1)+1,  //   (242)
    ('M' << 1)+1,  //   (243)
    ('M' << 1)+1,  //   (244)
    ('M' << 1)+1,  //   (245)
    ('M' << 1)+1,  //   (246)
    255,           //   (247)
    ('N' << 1)+0,  //   (248)
    ('A' << 1)+0,  // 
    ('A' << 1)+0,  // 
    ('A' << 1)+0,  //   (251)
    ('A' << 1)+0,  // 
    (BETA << 1)+1, // 
    ( 0  << 1)+1,  // 
    0              //   (255)
  };

//-------------------------------------------------------------------------
// Procedura pro pevod znaku na reprezentaci v Morseov abeced
// Funkce vyuv pevodn tabulku TRANS_TABLE
//
// Parametry:
//   c       Znak k peloen
//   outbuf  Vstupn etzec
void translate( unsigned char c, char *outbuf ) {
  int i;

  if ( (c == 32) || (c == 127) || (c == '\n') || (c == '\t')
        || (c == '<') || (c == '>') || (c == '?') || (c == 10)
        || (c == '"') || (c == 39) || (c == ':') || (c == '!')
        || (c == '(') || (c == ')') || (c == '{') || (c == '}')
        || (c == '=') || (c == '*') || (c == '_') || (c == '^')) {
    // Nepekldan znaky - pouze doplnit znak "/" pro oddlen
    outbuf[0] = c;
    outbuf[1] = '/';
    outbuf[2] = 0;
  } else {
    i = 0;
    // Peloen znaku do morseovky s pomoc pevodnho binrnho stromu
    do {
       outbuf[i] = ((TRANS_TABLE[c] & 1) == 0) ? '.' : '-';
       if (TRANS_TABLE[c]!=255) { // Oeten znak, kter nemaj peklad
          i++;
       }
    } while ( (c = (unsigned char)(TRANS_TABLE[c] >> 1)) != 0 );
    outbuf[i] = '/';  // doplnn oddlovae
    outbuf[i+1] = 0;
  }
}

//---------------------------------------------------------------------------
int main(int argc, char *argv[] )
{
     if (argc > 2) {
         char *in_name = argv[1];
         char *out_name = argv[2];
         char *options = "";
         unsigned char buf1, buf2 = 0;
         char *outstr;
         FILE *in, *out;

         if (argc > 3) {
           options = argv[3];
         }
         // alokace pamti pro pracovn etzec
         outstr = (char *) malloc(20);

         // --------- oseten vstupu -------------
         if ((in = fopen(in_name, "rt"))
             == NULL)
         {
            fprintf(stderr,
                    "Chyba pri otevreni vstupniho souboru \"%s\".\n",
                    in_name);
            return 1;
         }

         // Test na existenci vstupnho souboru
         if ( ((out = fopen(out_name, "rt")) != NULL)
              && (strcmp( options, "-f" )) )
         {
            fprintf(stderr,
                     strcat("Vystupni soubor \"%s\" existuje.\n",
                            "Prejete-li si jej prepsat, pouzijte prepinac -f"),
                    out_name);
            fclose(out);
            return 1;
         }

         if ((out = fopen(out_name, "wt"))
             == NULL)
         {
            fprintf(stderr,
                    "Chyba pri otevreni vystupniho souboru \"%s\".\n",
                    out_name);
            return 1;
         }
         // --------- /oseten vstupu ------------

         // ------------ zpracovn ------------
         while (!feof(in)) {
              // pokud 2. naten psmeno pi pedchozm ten nebylo H
              // tvoc CH, pouij ho jako vstup
              // => neti ze souboru, ale z buf2
            if (buf2 == 0) {
                buf1 = (unsigned char)fgetc(in);
            } else {
                buf1 = buf2;
                buf2 = 0;
            }
            // test na "CH"
              // jestlie jsme naetli "C", nateme jet jeden znak,
              // protoe kdyby to bylo "H", musme to zpracovat jako "CH"
            if (toupper(buf1)=='C') {
                if (!feof(in)) {
                    buf2 = (unsigned char)fgetc(in);
                } else {
                    buf2 = 0;
                }
                if (toupper(buf2)=='H') {
                    buf1 = CH;  // pouit zstupnho znaku pro CH
                    buf2 = 0;
                }
            }
            translate( buf1, outstr );  // peklad znaku do morseovky
              // vpis peloenho etzce do vstupnho souboru
            fprintf(out, outstr);
         }
         // ------------ /zpracovn ----------

         fclose(in);
         fclose(out);
         return 0;
     } else {
         // Pokud nejsou zadny parametry, vypsat npovdu
         printf("Program TELEGRAF - prevod souboru do morseovy abecedy.\n");
         printf("Pouziti: telegraf <vstupni soubor> <vystupni soubor> [-f]\n");
         printf("  -f  ...  prepsat existujici vystupni soubor\n");
         return 1;
     }
}
//---------------------------------------------------------------------------
